//	APane.h

#pragma once


#include "LPane.h"


class ScreenTarget;

class APane :
	public LPane
{
protected:
	ScreenTarget		*theTarget;
	void				*theData;
	long				tRowBytes;
	long				tWidth;
	long				tHeight;
	long				tHPos;
	long				tVPos;
public:
	static APane *		CreateAPaneStream(
							LStream *stream);
	enum {
		class_ID = 'APan'
	};

	void				FinishCreate();

						APane(
							LStream *inStream) :
							LPane(inStream)
						{
							theTarget = NULL;
							theData = NULL;
						}

	void				DrawSelf();

	void				SetData(
							void *data,
							long rowBytes,
							long width,
							long height,
							long hPos,
							long vPos);
	ScreenTarget		*GetScreenTarget() { return theTarget; }
};
