// InPoint.h

#pragma once


#include "NetPoint.h"

#include <OpenTptInternet.h>

struct packetBuffer {
	long	a;
	long	b;
	long	c;
	long	d;
	long	e;
	char	mScanBuffer[1500];
};


class InPoint :
	public NetPoint {

	
protected:
	union {
		InetAddress	inet;
	}			fHisAddress;
	long		fHisAddressSize;

	packetBuffer		fPacket;


public:

							InPoint(
								const char *protocol,
								const char *address,
								short port);
							~InPoint();

	
protected:
	static pascal void		Notifier(
								void* contextPtr,
								OTEventCode code, 
								OTResult result,
								void* cookie);
	void		 			HandleNotify(
								OTEventCode code,
								OTResult result,
								void* cookie);
	void					GetData();

	virtual void			DoSomethingWithTheData(
								void *data,
								long size);
};

