//	AWindow.h

#pragma once

#include <LWindow.h>


class ScreenTarget;
class DrawPoint;

class AWindow :
	public LWindow
{
protected:
	ScreenTarget		*fScreenTarget;
	DrawPoint			*fNetPoint;

	void				MaybeRefresh();

public:

	enum {
		class_ID = 'AWin'
	};

	static AWindow		*CreateWindow(
							short id,
							LCommander *super);
	static AWindow		*CreateWindowStream(
							LStream *stream);

						AWindow(
							LStream *inStream) : LWindow(inStream) { fNetPoint = NULL; }
	virtual				~AWindow();
	virtual void		SetNetPoint(
							DrawPoint *point)
						{
							fNetPoint = point;
						}
	virtual void		SetScreenTarget(
							ScreenTarget *aTarget)
						{
							fScreenTarget = aTarget;
						}
	void				DoSetPosition(Point inPosition);
	void				DoSetBounds(const Rect &inBounds);
	void				SendAESetPosition(Point, Boolean);

};
