//	NetPoint.h

#pragma once

#include <OpenTransport.h>
#include <OpenTptInternet.h>


class NetPoint

{
protected:
	Boolean		fCloseOnDestroy;
	EndpointRef	fEndpoint;
	union {
		InetAddress	inet;
	}			fMyAddress;
public:
				NetPoint();
	virtual		~NetPoint();

	virtual OSErr	Open(
						const char *protocol);
	virtual OSErr	Bind(
						short port);
	virtual OSErr	Close();

};

#define OUR_PORT 8799

