// InPoint.h


#include "NetPoint.h"

#include <OpenTptInternet.h>

struct packetBuffer {
	long	mScanSectionID;
	char	mScanBuffer[1200];
};


class InPoint : public NetPoint {

	
protected:
	union {
		InetAddress	inet;
	}			fHisAddress;
	long		fHisAddressSize;

	packetBuffer		fPacket;


public:

							InPoint(
								const char *protocol,
								const char *address,
								short port);
	virtual					~InPoint();

	
protected:
	static pascal void		Notifier(void* contextPtr, OTEventCode code, 
										   OTResult result, void* cookie);
	void		 			HandleNotify(OTEventCode code, OTResult result, void* cookie);
	void					GetData();

};